import { b as n } from "./common-64096f9e.js";
import { _ as e, d6 as t, d8 as r } from "./vendor-208d0ff5.js";
function o(n3) {
  return "Minified Redux error #" + n3 + "; visit https://redux.js.org/Errors?code=" + n3 + " for the full message or use the non-minified dev environment for full errors. ";
}
var a = "function" == typeof Symbol && Symbol.observable || "@@observable", c = function() {
  return Math.random().toString(36).substring(7).split("").join(".");
}, i = { INIT: "@@redux/INIT" + c(), REPLACE: "@@redux/REPLACE" + c(), PROBE_UNKNOWN_ACTION: function() {
  return "@@redux/PROBE_UNKNOWN_ACTION" + c();
} };
function u(n3) {
  if ("object" != typeof n3 || null === n3)
    return false;
  for (var e2 = n3; null !== Object.getPrototypeOf(e2); )
    e2 = Object.getPrototypeOf(e2);
  return Object.getPrototypeOf(n3) === e2;
}
function s(n3) {
  if (void 0 === n3)
    return "undefined";
  if (null === n3)
    return "null";
  var e2 = typeof n3;
  switch (e2) {
    case "boolean":
    case "string":
    case "number":
    case "symbol":
    case "function":
      return e2;
  }
  if (Array.isArray(n3))
    return "array";
  if (function(n4) {
    return n4 instanceof Date || "function" == typeof n4.toDateString && "function" == typeof n4.getDate && "function" == typeof n4.setDate;
  }(n3))
    return "date";
  if (function(n4) {
    return n4 instanceof Error || "string" == typeof n4.message && n4.constructor && "number" == typeof n4.constructor.stackTraceLimit;
  }(n3))
    return "error";
  var t2 = function(n4) {
    return "function" == typeof n4.constructor ? n4.constructor.name : null;
  }(n3);
  switch (t2) {
    case "Symbol":
    case "Promise":
    case "WeakMap":
    case "WeakSet":
    case "Map":
    case "Set":
      return t2;
  }
  return e2.slice(8, -1).toLowerCase().replace(/\s/g, "");
}
function f(n3) {
  var e2 = typeof n3;
  return "production" !== process.env.NODE_ENV && (e2 = s(n3)), e2;
}
function l(n3, e2, t2) {
  var r2;
  if ("function" == typeof e2 && "function" == typeof t2 || "function" == typeof t2 && "function" == typeof arguments[3])
    throw new Error("production" === process.env.NODE_ENV ? o(0) : "It looks like you are passing several store enhancers to createStore(). This is not supported. Instead, compose them together to a single function. See https://redux.js.org/tutorials/fundamentals/part-4-store#creating-a-store-with-enhancers for an example.");
  if ("function" == typeof e2 && void 0 === t2 && (t2 = e2, e2 = void 0), void 0 !== t2) {
    if ("function" != typeof t2)
      throw new Error("production" === process.env.NODE_ENV ? o(1) : "Expected the enhancer to be a function. Instead, received: '" + f(t2) + "'");
    return t2(l)(n3, e2);
  }
  if ("function" != typeof n3)
    throw new Error("production" === process.env.NODE_ENV ? o(2) : "Expected the root reducer to be a function. Instead, received: '" + f(n3) + "'");
  var c2 = n3, s2 = e2, d2 = [], p2 = d2, v2 = false;
  function h2() {
    p2 === d2 && (p2 = d2.slice());
  }
  function y2() {
    if (v2)
      throw new Error("production" === process.env.NODE_ENV ? o(3) : "You may not call store.getState() while the reducer is executing. The reducer has already received the state as an argument. Pass it down from the top reducer instead of reading it from the store.");
    return s2;
  }
  function E2(n4) {
    if ("function" != typeof n4)
      throw new Error("production" === process.env.NODE_ENV ? o(4) : "Expected the listener to be a function. Instead, received: '" + f(n4) + "'");
    if (v2)
      throw new Error("production" === process.env.NODE_ENV ? o(5) : "You may not call store.subscribe() while the reducer is executing. If you would like to be notified after the store has been updated, subscribe from a component and invoke store.getState() in the callback to access the latest state. See https://redux.js.org/api/store#subscribelistener for more details.");
    var e3 = true;
    return h2(), p2.push(n4), function() {
      if (e3) {
        if (v2)
          throw new Error("production" === process.env.NODE_ENV ? o(6) : "You may not unsubscribe from a store listener while the reducer is executing. See https://redux.js.org/api/store#subscribelistener for more details.");
        e3 = false, h2();
        var t3 = p2.indexOf(n4);
        p2.splice(t3, 1), d2 = null;
      }
    };
  }
  function g2(n4) {
    if (!u(n4))
      throw new Error("production" === process.env.NODE_ENV ? o(7) : "Actions must be plain objects. Instead, the actual type was: '" + f(n4) + "'. You may need to add middleware to your store setup to handle dispatching other values, such as 'redux-thunk' to handle dispatching functions. See https://redux.js.org/tutorials/fundamentals/part-4-store#middleware and https://redux.js.org/tutorials/fundamentals/part-6-async-logic#using-the-redux-thunk-middleware for examples.");
    if (void 0 === n4.type)
      throw new Error("production" === process.env.NODE_ENV ? o(8) : 'Actions may not have an undefined "type" property. You may have misspelled an action type string constant.');
    if (v2)
      throw new Error("production" === process.env.NODE_ENV ? o(9) : "Reducers may not dispatch actions.");
    try {
      v2 = true, s2 = c2(s2, n4);
    } finally {
      v2 = false;
    }
    for (var e3 = d2 = p2, t3 = 0; t3 < e3.length; t3++) {
      (0, e3[t3])();
    }
    return n4;
  }
  return g2({ type: i.INIT }), (r2 = { dispatch: g2, subscribe: E2, getState: y2, replaceReducer: function(n4) {
    if ("function" != typeof n4)
      throw new Error("production" === process.env.NODE_ENV ? o(10) : "Expected the nextReducer to be a function. Instead, received: '" + f(n4));
    c2 = n4, g2({ type: i.REPLACE });
  } })[a] = function() {
    var n4, e3 = E2;
    return (n4 = { subscribe: function(n5) {
      if ("object" != typeof n5 || null === n5)
        throw new Error("production" === process.env.NODE_ENV ? o(11) : "Expected the observer to be an object. Instead, received: '" + f(n5) + "'");
      function t3() {
        n5.next && n5.next(y2());
      }
      return t3(), { unsubscribe: e3(t3) };
    } })[a] = function() {
      return this;
    }, n4;
  }, r2;
}
var d = l;
function p(n3) {
  "undefined" != typeof console && "function" == typeof console.error && console.error(n3);
  try {
    throw new Error(n3);
  } catch (n4) {
  }
}
function v(n3) {
  for (var e2 = Object.keys(n3), t2 = {}, r2 = 0; r2 < e2.length; r2++) {
    var a2 = e2[r2];
    "production" !== process.env.NODE_ENV && void 0 === n3[a2] && p('No reducer provided for key "' + a2 + '"'), "function" == typeof n3[a2] && (t2[a2] = n3[a2]);
  }
  var c2, s2, l2 = Object.keys(t2);
  "production" !== process.env.NODE_ENV && (c2 = {});
  try {
    !function(n4) {
      Object.keys(n4).forEach(function(e3) {
        var t3 = n4[e3];
        if (void 0 === t3(void 0, { type: i.INIT }))
          throw new Error("production" === process.env.NODE_ENV ? o(12) : 'The slice reducer for key "' + e3 + `" returned undefined during initialization. If the state passed to the reducer is undefined, you must explicitly return the initial state. The initial state may not be undefined. If you don't want to set a value for this reducer, you can use null instead of undefined.`);
        if (void 0 === t3(void 0, { type: i.PROBE_UNKNOWN_ACTION() }))
          throw new Error("production" === process.env.NODE_ENV ? o(13) : 'The slice reducer for key "' + e3 + `" returned undefined when probed with a random type. Don't try to handle '` + i.INIT + `' or other actions in "redux/*" namespace. They are considered private. Instead, you must return the current state for any unknown actions, unless it is undefined, in which case you must return the initial state, regardless of the action type. The initial state may not be undefined, but can be null.`);
      });
    }(t2);
  } catch (n4) {
    s2 = n4;
  }
  return function(n4, e3) {
    if (void 0 === n4 && (n4 = {}), s2)
      throw s2;
    if ("production" !== process.env.NODE_ENV) {
      var r3 = function(n5, e4, t3, r4) {
        var o2 = Object.keys(e4), a4 = t3 && t3.type === i.INIT ? "preloadedState argument passed to createStore" : "previous state received by the reducer";
        if (0 === o2.length)
          return "Store does not have a valid reducer. Make sure the argument passed to combineReducers is an object whose values are reducers.";
        if (!u(n5))
          return "The " + a4 + ' has unexpected type of "' + f(n5) + '". Expected argument to be an object with the following keys: "' + o2.join('", "') + '"';
        var c3 = Object.keys(n5).filter(function(n6) {
          return !e4.hasOwnProperty(n6) && !r4[n6];
        });
        return c3.forEach(function(n6) {
          r4[n6] = true;
        }), t3 && t3.type === i.REPLACE ? void 0 : c3.length > 0 ? "Unexpected " + (c3.length > 1 ? "keys" : "key") + ' "' + c3.join('", "') + '" found in ' + a4 + '. Expected to find one of the known reducer keys instead: "' + o2.join('", "') + '". Unexpected keys will be ignored.' : void 0;
      }(n4, t2, e3, c2);
      r3 && p(r3);
    }
    for (var a3 = false, d2 = {}, v2 = 0; v2 < l2.length; v2++) {
      var h2 = l2[v2], y2 = t2[h2], E2 = n4[h2], g2 = y2(E2, e3);
      if (void 0 === g2) {
        var m2 = e3 && e3.type;
        throw new Error("production" === process.env.NODE_ENV ? o(14) : "When called with an action of type " + (m2 ? '"' + String(m2) + '"' : "(unknown type)") + ', the slice reducer for key "' + h2 + '" returned undefined. To ignore an action, you must explicitly return the previous state. If you want this reducer to hold no value, you can return null instead of undefined.');
      }
      d2[h2] = g2, a3 = a3 || g2 !== E2;
    }
    return (a3 = a3 || l2.length !== Object.keys(n4).length) ? d2 : n4;
  };
}
function h(n3, e2) {
  return function() {
    return e2(n3.apply(this, arguments));
  };
}
function y() {
  for (var n3 = arguments.length, e2 = new Array(n3), t2 = 0; t2 < n3; t2++)
    e2[t2] = arguments[t2];
  return 0 === e2.length ? function(n4) {
    return n4;
  } : 1 === e2.length ? e2[0] : e2.reduce(function(n4, e3) {
    return function() {
      return n4(e3.apply(void 0, arguments));
    };
  });
}
function E() {
  for (var n3 = arguments.length, t2 = new Array(n3), r2 = 0; r2 < n3; r2++)
    t2[r2] = arguments[r2];
  return function(n4) {
    return function() {
      var r3 = n4.apply(void 0, arguments), a2 = function() {
        throw new Error("production" === process.env.NODE_ENV ? o(15) : "Dispatching while constructing your middleware is not allowed. Other middleware would not be applied to this dispatch.");
      }, c2 = { getState: r3.getState, dispatch: function() {
        return a2.apply(void 0, arguments);
      } }, i2 = t2.map(function(n5) {
        return n5(c2);
      });
      return a2 = y.apply(void 0, i2)(r3.dispatch), e(e({}, r3), {}, { dispatch: a2 });
    };
  };
}
const g = Object.freeze(Object.defineProperty({ __proto__: null, __DO_NOT_USE__ActionTypes: i, applyMiddleware: E, bindActionCreators: function(n3, e2) {
  if ("function" == typeof n3)
    return h(n3, e2);
  if ("object" != typeof n3 || null === n3)
    throw new Error("production" === process.env.NODE_ENV ? o(16) : "bindActionCreators expected an object or a function, but instead received: '" + f(n3) + `'. Did you write "import ActionCreators from" instead of "import * as ActionCreators from"?`);
  var t2 = {};
  for (var r2 in n3) {
    var a2 = n3[r2];
    "function" == typeof a2 && (t2[r2] = h(a2, e2));
  }
  return t2;
}, combineReducers: v, compose: y, createStore: l, legacy_createStore: d }, Symbol.toStringTag, { value: "Module" }));
var m = {}, w = {};
Object.defineProperty(w, "__esModule", { value: true }), w.reduxBatch = function(n3) {
  var e2 = [], t2 = void 0;
  function r2() {
    e2 === t2 && (e2 = e2.slice());
  }
  function o2(n4) {
    if ("function" != typeof n4)
      throw new Error("Invalid listener, expected a function");
    var t3 = true;
    return r2(), e2.push(n4), function() {
      t3 && (r2(), e2.splice(e2.indexOf(n4), 1), t3 = false);
    };
  }
  function a2() {
    for (var n4 = e2, r3 = 0; r3 < n4.length; ++r3)
      t2 = n4, n4[r3]();
  }
  return function() {
    var e3 = n3.apply(void 0, arguments), t3 = false, r3 = false;
    function c2(n4) {
      return Array.isArray(n4) ? n4.map(function(n5) {
        return c2(n5);
      }) : e3.dispatch(n4);
    }
    return e3.subscribe(function() {
      r3 ? t3 = true : a2();
    }), Object.assign({}, e3, { dispatch: function(n4) {
      var e4 = r3;
      e4 || (t3 = false, r3 = true);
      var o3 = c2(n4), i2 = t3 && !e4;
      return e4 || (t3 = false, r3 = false), i2 && a2(), o3;
    }, subscribe: o2 });
  };
}, function(n3) {
  Object.defineProperty(n3, "__esModule", { value: true });
  var e2 = w;
  Object.defineProperty(n3, "reduxBatch", { enumerable: true, get: function() {
    return e2.reduxBatch;
  } });
}(m);
var b = m;
const N = n(g);
var O = {}, _ = Object.keys || function(n3) {
  var e2 = [];
  for (var t2 in n3)
    ({}).hasOwnProperty.call(n3, t2) && e2.push(t2);
  return e2;
};
var S = function(n3, e2, t2) {
  for (var r2 = _(n3), o2 = {}, a2 = 0, c2 = r2.length; a2 < c2; a2++) {
    var i2 = r2[a2];
    o2[i2] = n3[i2];
  }
  return o2[e2] = t2, o2;
}, k = N.compose;
function x() {
  var n3 = arguments[0] || {};
  return n3.features = { pause: true, export: true, test: true }, n3.type = "redux", void 0 === n3.autoPause && (n3.autoPause = true), void 0 === n3.latency && (n3.latency = 500), function(e2) {
    return function(t2, r2, o2) {
      var a2 = e2(t2, r2, o2), c2 = a2.dispatch, i2 = window.__REDUX_DEVTOOLS_EXTENSION__.connect(n3);
      i2.init(a2.getState());
      var u2 = function(n4) {
        var e3 = c2(n4);
        return i2.send(n4, a2.getState()), e3;
      };
      return Object.assign ? Object.assign(a2, { dispatch: u2 }) : S(a2, "dispatch", u2);
    };
  };
}
function D(n3) {
  return function() {
    return k(k.apply(null, arguments), x(n3));
  };
}
O.__esModule = true, O.composeWithDevTools = function() {
  return "undefined" != typeof window && window.__REDUX_DEVTOOLS_EXTENSION__ ? 0 === arguments.length ? x() : "object" == typeof arguments[0] ? D(arguments[0]) : D().apply(null, arguments) : 0 !== arguments.length ? "object" == typeof arguments[0] ? k : k.apply(null, arguments) : void 0;
}, O.devToolsEnhancer = "undefined" != typeof window && window.__REDUX_DEVTOOLS_EXTENSION__ ? x : function() {
  return function(n3) {
    return n3;
  };
};
var T = N.compose, j = O, A = "production" === process.env.NODE_ENV ? j.composeWithDevTools : "undefined" != typeof window && window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ ? window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ : function() {
  if (0 !== arguments.length)
    return "object" == typeof arguments[0] ? T : T.apply(null, arguments);
}, V = function(n3) {
  return "@@redux-saga/" + n3;
}, C = V("CANCEL_PROMISE"), I = V("CHANNEL_END"), R = V("IO"), P = V("MATCH"), M = V("MULTICAST"), L = V("SAGA_ACTION"), U = V("SELF_CANCELLATION"), q = V("TASK"), X = V("TASK_CANCEL"), z = V("TERMINATE"), B = V("LOCATION"), W = function(n3) {
  return null == n3;
}, K = function(n3) {
  return null != n3;
}, H = function(n3) {
  return "function" == typeof n3;
}, Y = function(n3) {
  return "string" == typeof n3;
}, F = Array.isArray, G = function(n3) {
  return n3 && !F(n3) && "object" == typeof n3;
}, J = function(n3) {
  return n3 && H(n3.then);
}, Q = function(n3) {
  return n3 && H(n3.next) && H(n3.throw);
}, Z = function(n3) {
  return n3 && n3[q];
}, $ = function(n3) {
  return n3 && H(n3.isEmpty) && H(n3.take) && H(n3.put);
}, nn = function n2(e2) {
  return e2 && (Y(e2) || rn(e2) || H(e2) || F(e2) && e2.every(n2));
}, en = function(n3) {
  return n3 && H(n3.take) && H(n3.close);
}, tn = function(n3) {
  return H(n3) && n3.hasOwnProperty("toString");
}, rn = function(n3) {
  return Boolean(n3) && "function" == typeof Symbol && n3.constructor === Symbol && n3 !== Symbol.prototype;
}, on = function(n3) {
  return en(n3) && n3[M];
}, an = function(n3) {
  return n3 && n3[R];
}, cn = 2147483647;
function un(n3, e2) {
  if (void 0 === e2 && (e2 = true), "production" !== process.env.NODE_ENV && n3 > cn)
    throw new Error("delay only supports a maximum value of " + cn + "ms");
  var t2, r2 = new Promise(function(r3) {
    t2 = setTimeout(r3, Math.min(cn, n3), e2);
  });
  return r2[C] = function() {
    clearTimeout(t2);
  }, r2;
}
var sn = function(n3) {
  return function() {
    return n3;
  };
}(true), fn = function() {
};
"production" !== process.env.NODE_ENV && "undefined" != typeof Proxy && (fn = new Proxy(fn, { set: function() {
  throw wn("There was an attempt to assign a property to internal `noop` function.");
} }));
var ln = function(n3) {
  return n3;
}, dn = "function" == typeof Symbol && Symbol.asyncIterator ? Symbol.asyncIterator : "@@asyncIterator";
function pn(n3, e2, t2) {
  if (!e2(n3))
    throw new Error(t2);
}
var vn = function(n3, e2) {
  t(n3, e2), Object.getOwnPropertySymbols && Object.getOwnPropertySymbols(e2).forEach(function(t2) {
    n3[t2] = e2[t2];
  });
};
function hn(n3, e2) {
  var t2 = n3.indexOf(e2);
  t2 >= 0 && n3.splice(t2, 1);
}
var yn = function(n3) {
  throw n3;
}, En = function(n3) {
  return { value: n3, done: true };
};
function gn(n3, e2, t2) {
  void 0 === e2 && (e2 = yn), void 0 === t2 && (t2 = "iterator");
  var r2 = { meta: { name: t2 }, next: n3, throw: e2, return: En, isSagaIterator: true };
  return "undefined" != typeof Symbol && (r2[Symbol.iterator] = function() {
    return r2;
  }), r2;
}
function mn(n3, e2) {
  var t2 = e2.sagaStack;
  console.error(n3), console.error(t2);
}
var wn = function(n3) {
  return new Error("\n  redux-saga: Error checking hooks detected an inconsistent state. This is likely a bug\n  in redux-saga code and not yours. Thanks for reporting this in the project's github repo.\n  Error: " + n3 + "\n");
}, bn = function(n3, e2) {
  return (n3 ? n3 + "." : "") + "setContext(props): argument " + e2 + " is not a plain object";
}, Nn = function(n3) {
  return Array.apply(null, new Array(n3));
}, On = function(n3) {
  return function(e2) {
    return "production" !== process.env.NODE_ENV && pn(e2, function(n4) {
      return !Object.isFrozen(n4);
    }, "You can't put (a.k.a. dispatch from saga) frozen actions.\nWe have to define a special non-enumerable property on those actions for scheduling purposes.\nOtherwise you wouldn't be able to communicate properly between sagas & other subscribers (action ordering would become far less predictable).\nIf you are using redux and you care about this behaviour (frozen actions),\nthen you might want to switch to freezing actions in a middleware rather than in action creator.\nExample implementation:\n\nconst freezeActions = store => next => action => next(Object.freeze(action))\n"), n3(Object.defineProperty(e2, L, { value: true }));
  };
}, _n = function(n3) {
  return n3 === z;
}, Sn = function(n3) {
  return n3 === X;
}, kn = function(n3) {
  return _n(n3) || Sn(n3);
};
function xn(n3, e2) {
  var t2 = Object.keys(n3), r2 = t2.length;
  "production" !== process.env.NODE_ENV && pn(r2, function(n4) {
    return n4 > 0;
  }, "createAllStyleChildCallbacks: get an empty array or object");
  var o2, a2 = 0, c2 = F(n3) ? Nn(r2) : {}, i2 = {};
  return t2.forEach(function(n4) {
    var t3 = function(t4, i3) {
      o2 || (i3 || kn(t4) ? (e2.cancel(), e2(t4, i3)) : (c2[n4] = t4, ++a2 === r2 && (o2 = true, e2(c2))));
    };
    t3.cancel = fn, i2[n4] = t3;
  }), e2.cancel = function() {
    o2 || (o2 = true, t2.forEach(function(n4) {
      return i2[n4].cancel();
    }));
  }, i2;
}
function Dn(n3) {
  return { name: n3.name || "anonymous", location: Tn(n3) };
}
function Tn(n3) {
  return n3[B];
}
function jn() {
  for (var n3 = arguments.length, e2 = new Array(n3), t2 = 0; t2 < n3; t2++)
    e2[t2] = arguments[t2];
  return 0 === e2.length ? function(n4) {
    return n4;
  } : 1 === e2.length ? e2[0] : e2.reduce(function(n4, e3) {
    return function() {
      return n4(e3.apply(void 0, arguments));
    };
  });
}
var An = function(n3) {
  return function(n4, e2) {
    void 0 === n4 && (n4 = 10);
    var t2 = new Array(n4), r2 = 0, o2 = 0, a2 = 0, c2 = function(e3) {
      t2[o2] = e3, o2 = (o2 + 1) % n4, r2++;
    }, i2 = function() {
      if (0 != r2) {
        var e3 = t2[a2];
        return t2[a2] = null, r2--, a2 = (a2 + 1) % n4, e3;
      }
    }, u2 = function() {
      for (var n5 = []; r2; )
        n5.push(i2());
      return n5;
    };
    return { isEmpty: function() {
      return 0 == r2;
    }, put: function(i3) {
      var s2;
      if (r2 < n4)
        c2(i3);
      else
        switch (e2) {
          case 1:
            throw new Error("Channel's Buffer overflow!");
          case 3:
            t2[o2] = i3, a2 = o2 = (o2 + 1) % n4;
            break;
          case 4:
            s2 = 2 * n4, t2 = u2(), r2 = t2.length, o2 = t2.length, a2 = 0, t2.length = s2, n4 = s2, c2(i3);
        }
    }, take: i2, flush: u2 };
  }(n3, 4);
}, Vn = "TAKE", Cn = "CALL", In = "FORK", Rn = "CANCEL", Pn = "SELECT", Mn = "\n(HINT: if you are getting these errors in tests, consider using createMockTask from @redux-saga/testing-utils)", Ln = function(n3, e2) {
  var t2;
  return (t2 = {})[R] = true, t2.combinator = false, t2.type = n3, t2.payload = e2, t2;
}, Un = function(n3) {
  return an(n3) && n3.type === In;
};
function qn(n3, e2) {
  if (void 0 === n3 && (n3 = "*"), "production" !== process.env.NODE_ENV && arguments.length && pn(arguments[0], K, "take(patternOrChannel): patternOrChannel is undefined"), nn(n3))
    return K(e2) && console.warn("take(pattern) takes one argument but two were provided. Consider passing an array for listening to several action types"), Ln(Vn, { pattern: n3 });
  if (on(n3) && K(e2) && nn(e2))
    return Ln(Vn, { channel: n3, pattern: e2 });
  if (en(n3))
    return K(e2) && console.warn("take(channel) takes one argument but two were provided. Second argument is ignored."), Ln(Vn, { channel: n3 });
  if ("production" !== process.env.NODE_ENV)
    throw new Error("take(patternOrChannel): argument " + n3 + " is not valid channel or a valid pattern");
}
function Xn(n3, e2) {
  return "production" !== process.env.NODE_ENV && (arguments.length > 1 ? (pn(n3, K, "put(channel, action): argument channel is undefined"), pn(n3, en, "put(channel, action): argument " + n3 + " is not a valid channel"), pn(e2, K, "put(channel, action): argument action is undefined")) : pn(n3, K, "put(action): argument action is undefined")), W(e2) && (e2 = n3, n3 = void 0), Ln("PUT", { channel: n3, action: e2 });
}
function zn(n3) {
  var e2 = Ln("ALL", n3);
  return e2.combinator = true, e2;
}
var Bn = function(n3, e2) {
  if (pn(e2, K, n3 + ": argument fn is undefined or null"), !H(e2)) {
    var t2, r2 = null;
    if (F(e2))
      r2 = e2[0], pn(t2 = e2[1], K, n3 + ": argument of type [context, fn] has undefined or null `fn`");
    else {
      if (!G(e2))
        return void pn(e2, H, n3 + ": argument fn is not function");
      r2 = e2.context, pn(t2 = e2.fn, K, n3 + ": argument of type {context, fn} has undefined or null `fn`");
    }
    r2 && Y(t2) ? pn(r2[t2], H, n3 + ': context arguments has no such method - "' + t2 + '"') : pn(t2, H, n3 + ": unpacked fn argument (from [context, fn] or {context, fn}) is not a function");
  }
};
function Wn(n3, e2) {
  var t2, r2 = null;
  return H(n3) ? t2 = n3 : (F(n3) ? (r2 = n3[0], t2 = n3[1]) : (r2 = n3.context, t2 = n3.fn), r2 && Y(t2) && H(r2[t2]) && (t2 = r2[t2])), { context: r2, fn: t2, args: e2 };
}
var Kn = function(n3) {
  return n3 !== Qn;
};
function Hn(n3) {
  for (var e2 = arguments.length, t2 = new Array(e2 > 1 ? e2 - 1 : 0), r2 = 1; r2 < e2; r2++)
    t2[r2 - 1] = arguments[r2];
  if ("production" !== process.env.NODE_ENV) {
    var o2 = "number" == typeof t2[0] ? t2[0] : "ms";
    pn(n3, Kn, "instead of writing `yield call(delay, " + o2 + ")` where delay is an effect from `redux-saga/effects` you should write `yield delay(" + o2 + ")`"), Bn("call", n3);
  }
  return Ln(Cn, Wn(n3, t2));
}
function Yn(n3) {
  "production" !== process.env.NODE_ENV && (Bn("fork", n3), pn(n3, function(n4) {
    return !an(n4);
  }, "fork: argument must not be an effect"));
  for (var e2 = arguments.length, t2 = new Array(e2 > 1 ? e2 - 1 : 0), r2 = 1; r2 < e2; r2++)
    t2[r2 - 1] = arguments[r2];
  return Ln(In, Wn(n3, t2));
}
function Fn(n3) {
  "production" !== process.env.NODE_ENV && Bn("spawn", n3);
  for (var e2 = arguments.length, r2 = new Array(e2 > 1 ? e2 - 1 : 0), o2 = 1; o2 < e2; o2++)
    r2[o2 - 1] = arguments[o2];
  return a2 = Yn.apply(void 0, [n3].concat(r2)), "production" !== process.env.NODE_ENV && pn(a2, Un, "detach(eff): argument must be a fork effect"), Ln(In, t({}, a2.payload, { detached: true }));
  var a2;
}
function Gn(n3) {
  if (void 0 === n3 && (n3 = U), "production" !== process.env.NODE_ENV) {
    if (arguments.length > 1)
      throw new Error("cancel(...tasks) is not supported any more. Please use cancel([...tasks]) to cancel multiple tasks.");
    F(n3) ? n3.forEach(function(n4) {
      pn(n4, Z, "cancel([...tasks]): argument " + n4 + " is not a valid Task object " + Mn);
    }) : n3 !== U && K(n3) && pn(n3, Z, "cancel(task): argument " + n3 + " is not a valid Task object " + Mn);
  }
  return Ln(Rn, n3);
}
function Jn(n3) {
  void 0 === n3 && (n3 = ln);
  for (var e2 = arguments.length, t2 = new Array(e2 > 1 ? e2 - 1 : 0), r2 = 1; r2 < e2; r2++)
    t2[r2 - 1] = arguments[r2];
  return "production" !== process.env.NODE_ENV && arguments.length && (pn(arguments[0], K, "select(selector, [...]): argument selector is undefined"), pn(n3, H, "select(selector, [...]): argument " + n3 + " is not a function")), Ln(Pn, { selector: n3, args: t2 });
}
var Qn = Hn.bind(null, un);
var Zn = [], $n = 0;
function ne(n3) {
  try {
    re(), n3();
  } finally {
    oe();
  }
}
function ee(n3) {
  Zn.push(n3), $n || (re(), ae());
}
function te(n3) {
  try {
    return re(), n3();
  } finally {
    ae();
  }
}
function re() {
  $n++;
}
function oe() {
  $n--;
}
function ae() {
  var n3;
  for (oe(); !$n && void 0 !== (n3 = Zn.shift()); )
    ne(n3);
}
var ce = function(n3) {
  return function(e2) {
    return n3.some(function(n4) {
      return le(n4)(e2);
    });
  };
}, ie = function(n3) {
  return function(e2) {
    return n3(e2);
  };
}, ue = function(n3) {
  return function(e2) {
    return e2.type === String(n3);
  };
}, se = function(n3) {
  return function(e2) {
    return e2.type === n3;
  };
}, fe = function() {
  return sn;
};
function le(n3) {
  var e2 = "*" === n3 ? fe : Y(n3) ? ue : F(n3) ? ce : tn(n3) ? ue : H(n3) ? ie : rn(n3) ? se : null;
  if (null === e2)
    throw new Error("invalid pattern: " + n3);
  return e2(n3);
}
var de = { type: I }, pe = function(n3) {
  return n3 && n3.type === I;
}, ve = "Cannot have a closed channel with pending takers", he = "invalid buffer passed to channel factory function", ye = "Saga or channel was provided with an undefined action\nHints:\n  - check that your Action Creator returns a non-undefined value\n  - if the Saga was started using runSaga, check that your subscribe source provides the action to its listeners";
function Ee(n3) {
  void 0 === n3 && (n3 = An());
  var e2 = false, t2 = [];
  function r2() {
    if (e2 && t2.length)
      throw wn(ve);
    if (t2.length && !n3.isEmpty())
      throw wn("Cannot have pending takers with non empty buffer");
  }
  return "production" !== process.env.NODE_ENV && pn(n3, $, he), { take: function(o2) {
    "production" !== process.env.NODE_ENV && (r2(), pn(o2, H, "channel.take's callback must be a function")), e2 && n3.isEmpty() ? o2(de) : n3.isEmpty() ? (t2.push(o2), o2.cancel = function() {
      hn(t2, o2);
    }) : o2(n3.take());
  }, put: function(o2) {
    if ("production" !== process.env.NODE_ENV && (r2(), pn(o2, K, ye)), !e2) {
      if (0 === t2.length)
        return n3.put(o2);
      t2.shift()(o2);
    }
  }, flush: function(t3) {
    "production" !== process.env.NODE_ENV && (r2(), pn(t3, H, "channel.flush' callback must be a function")), e2 && n3.isEmpty() ? t3(de) : t3(n3.flush());
  }, close: function() {
    if ("production" !== process.env.NODE_ENV && r2(), !e2) {
      e2 = true;
      var n4 = t2;
      t2 = [];
      for (var o2 = 0, a2 = n4.length; o2 < a2; o2++) {
        (0, n4[o2])(de);
      }
    }
  } };
}
function ge() {
  var n3 = function() {
    var n4, e3 = false, t2 = [], r2 = t2;
    function o2() {
      if (e3 && r2.length)
        throw wn(ve);
    }
    var a2 = function() {
      r2 === t2 && (r2 = t2.slice());
    }, c2 = function() {
      "production" !== process.env.NODE_ENV && o2(), e3 = true;
      var n5 = t2 = r2;
      r2 = [], n5.forEach(function(n6) {
        n6(de);
      });
    };
    return (n4 = {})[M] = true, n4.put = function(n5) {
      if ("production" !== process.env.NODE_ENV && (o2(), pn(n5, K, ye)), !e3)
        if (pe(n5))
          c2();
        else
          for (var a3 = t2 = r2, i2 = 0, u2 = a3.length; i2 < u2; i2++) {
            var s2 = a3[i2];
            s2[P](n5) && (s2.cancel(), s2(n5));
          }
    }, n4.take = function(n5, t3) {
      var c3, i2;
      void 0 === t3 && (t3 = fe), "production" !== process.env.NODE_ENV && o2(), e3 ? n5(de) : (n5[P] = t3, a2(), r2.push(n5), n5.cancel = (c3 = function() {
        a2(), hn(r2, n5);
      }, i2 = false, function() {
        i2 || (i2 = true, c3());
      }));
    }, n4.close = c2, n4;
  }(), e2 = n3.put;
  return n3.put = function(n4) {
    n4[L] ? e2(n4) : ee(function() {
      e2(n4);
    });
  }, n3;
}
var me = 0, we = 1, be = 2, Ne = 3;
function Oe(n3, e2) {
  var t2 = n3[C];
  H(t2) && (e2.cancel = t2), n3.then(e2, function(n4) {
    e2(n4, true);
  });
}
var _e, Se = 0, ke = function() {
  return ++Se;
};
function xe(n3) {
  n3.isRunning() && n3.cancel();
}
var De = ((_e = {})[Vn] = function(n3, e2, t2) {
  var r2 = e2.channel, o2 = void 0 === r2 ? n3.channel : r2, a2 = e2.pattern, c2 = e2.maybe, i2 = function(n4) {
    n4 instanceof Error ? t2(n4, true) : !pe(n4) || c2 ? t2(n4) : t2(z);
  };
  try {
    o2.take(i2, K(a2) ? le(a2) : null);
  } catch (n4) {
    return void t2(n4, true);
  }
  t2.cancel = i2.cancel;
}, _e.PUT = function(n3, e2, t2) {
  var r2 = e2.channel, o2 = e2.action, a2 = e2.resolve;
  ee(function() {
    var e3;
    try {
      e3 = (r2 ? r2.put : n3.dispatch)(o2);
    } catch (n4) {
      return void t2(n4, true);
    }
    a2 && J(e3) ? Oe(e3, t2) : t2(e3);
  });
}, _e.ALL = function(n3, e2, t2, r2) {
  var o2 = r2.digestEffect, a2 = Se, c2 = Object.keys(e2);
  if (0 !== c2.length) {
    var i2 = xn(e2, t2);
    c2.forEach(function(n4) {
      o2(e2[n4], a2, i2[n4], n4);
    });
  } else
    t2(F(e2) ? [] : {});
}, _e.RACE = function(n3, e2, t2, r2) {
  var o2 = r2.digestEffect, a2 = Se, c2 = Object.keys(e2), i2 = F(e2) ? Nn(c2.length) : {}, u2 = {}, s2 = false;
  c2.forEach(function(n4) {
    var e3 = function(e4, r3) {
      s2 || (r3 || kn(e4) ? (t2.cancel(), t2(e4, r3)) : (t2.cancel(), s2 = true, i2[n4] = e4, t2(i2)));
    };
    e3.cancel = fn, u2[n4] = e3;
  }), t2.cancel = function() {
    s2 || (s2 = true, c2.forEach(function(n4) {
      return u2[n4].cancel();
    }));
  }, c2.forEach(function(n4) {
    s2 || o2(e2[n4], a2, u2[n4], n4);
  });
}, _e[Cn] = function(n3, e2, t2, r2) {
  var o2 = e2.context, a2 = e2.fn, c2 = e2.args, i2 = r2.task;
  try {
    var u2 = a2.apply(o2, c2);
    if (J(u2))
      return void Oe(u2, t2);
    if (Q(u2))
      return void Ue(n3, u2, i2.context, Se, Dn(a2), false, t2);
    t2(u2);
  } catch (n4) {
    t2(n4, true);
  }
}, _e.CPS = function(n3, e2, t2) {
  var r2 = e2.context, o2 = e2.fn, a2 = e2.args;
  try {
    var c2 = function(n4, e3) {
      W(n4) ? t2(e3) : t2(n4, true);
    };
    o2.apply(r2, a2.concat(c2)), c2.cancel && (t2.cancel = c2.cancel);
  } catch (n4) {
    t2(n4, true);
  }
}, _e[In] = function(n3, e2, t2, r2) {
  var o2 = e2.context, a2 = e2.fn, c2 = e2.args, i2 = e2.detached, u2 = r2.task, s2 = function(n4) {
    var e3 = n4.context, t3 = n4.fn, r3 = n4.args;
    try {
      var o3 = t3.apply(e3, r3);
      if (Q(o3))
        return o3;
      var a3 = false;
      return gn(function(n5) {
        return a3 ? { value: n5, done: true } : (a3 = true, { value: o3, done: !J(o3) });
      });
    } catch (n5) {
      return gn(function() {
        throw n5;
      });
    }
  }({ context: o2, fn: a2, args: c2 }), f2 = function(n4, e3) {
    return n4.isSagaIterator ? { name: n4.meta.name } : Dn(e3);
  }(s2, a2);
  te(function() {
    var e3 = Ue(n3, s2, u2.context, Se, f2, i2, void 0);
    i2 ? t2(e3) : e3.isRunning() ? (u2.queue.addTask(e3), t2(e3)) : e3.isAborted() ? u2.queue.abort(e3.error()) : t2(e3);
  });
}, _e.JOIN = function(n3, e2, t2, r2) {
  var o2 = r2.task, a2 = function(n4, e3) {
    if (n4.isRunning()) {
      var t3 = { task: o2, cb: e3 };
      e3.cancel = function() {
        n4.isRunning() && hn(n4.joiners, t3);
      }, n4.joiners.push(t3);
    } else
      n4.isAborted() ? e3(n4.error(), true) : e3(n4.result());
  };
  if (F(e2)) {
    if (0 === e2.length)
      return void t2([]);
    var c2 = xn(e2, t2);
    e2.forEach(function(n4, e3) {
      a2(n4, c2[e3]);
    });
  } else
    a2(e2, t2);
}, _e[Rn] = function(n3, e2, t2, r2) {
  var o2 = r2.task;
  e2 === U ? xe(o2) : F(e2) ? e2.forEach(xe) : xe(e2), t2();
}, _e[Pn] = function(n3, e2, t2) {
  var r2 = e2.selector, o2 = e2.args;
  try {
    t2(r2.apply(void 0, [n3.getState()].concat(o2)));
  } catch (n4) {
    t2(n4, true);
  }
}, _e.ACTION_CHANNEL = function(n3, e2, t2) {
  var r2 = e2.pattern, o2 = Ee(e2.buffer), a2 = le(r2), c2 = function e3(t3) {
    pe(t3) || n3.channel.take(e3, a2), o2.put(t3);
  }, i2 = o2.close;
  o2.close = function() {
    c2.cancel(), i2();
  }, n3.channel.take(c2, a2), t2(o2);
}, _e.CANCELLED = function(n3, e2, t2, r2) {
  t2(r2.task.isCancelled());
}, _e.FLUSH = function(n3, e2, t2) {
  e2.flush(t2);
}, _e.GET_CONTEXT = function(n3, e2, t2, r2) {
  t2(r2.task.context[e2]);
}, _e.SET_CONTEXT = function(n3, e2, t2, r2) {
  var o2 = r2.task;
  vn(o2.context, e2), t2();
}, _e);
function Te(n3, e2) {
  return n3 + "?" + e2;
}
function je(n3) {
  var e2 = n3.name, t2 = n3.location;
  return t2 ? e2 + "  " + Te(t2.fileName, t2.lineNumber) : e2;
}
function Ae(n3) {
  var e2, t2, r2, o2 = (e2 = function(n4) {
    return n4.cancelledTasks;
  }, t2 = n3, (r2 = []).concat.apply(r2, t2.map(e2)));
  return o2.length ? ["Tasks cancelled due to error:"].concat(o2).join("\n") : "";
}
var Ve = null, Ce = [], Ie = function(n3) {
  n3.crashedEffect = Ve, Ce.push(n3);
}, Re = function() {
  Ve = null, Ce.length = 0;
}, Pe = function(n3) {
  Ve = n3;
}, Me = function() {
  var n3 = Ce[0], e2 = Ce.slice(1), t2 = n3.crashedEffect ? function(n4) {
    var e3 = Tn(n4);
    return e3 ? e3.code + "  " + Te(e3.fileName, e3.lineNumber) : "";
  }(n3.crashedEffect) : null;
  return ["The above error occurred in task " + je(n3.meta) + (t2 ? " \n when executing effect " + t2 : "")].concat(e2.map(function(n4) {
    return "    created by " + je(n4.meta);
  }), [Ae(Ce)]).join("\n");
};
function Le(n3, e2, t2, r2, o2, a2, c2) {
  var i2;
  void 0 === c2 && (c2 = fn);
  var u2, s2, f2 = me, l2 = null, d2 = [], p2 = Object.create(t2), v2 = function(n4, e3, t3) {
    var r3, o3 = [], a3 = false;
    function c3(n5) {
      e3(), u3(), t3(n5, true);
    }
    function i3(e4) {
      o3.push(e4), e4.cont = function(i4, u4) {
        a3 || (hn(o3, e4), e4.cont = fn, u4 ? c3(i4) : (e4 === n4 && (r3 = i4), o3.length || (a3 = true, t3(r3))));
      };
    }
    function u3() {
      a3 || (a3 = true, o3.forEach(function(n5) {
        n5.cont = fn, n5.cancel();
      }), o3 = []);
    }
    return i3(n4), { addTask: i3, cancelAll: u3, abort: c3, getTasks: function() {
      return o3;
    } };
  }(e2, function() {
    d2.push.apply(d2, v2.getTasks().map(function(n4) {
      return n4.meta.name;
    }));
  }, h2);
  function h2(e3, t3) {
    if (t3) {
      if (f2 = be, Ie({ meta: o2, cancelledTasks: d2 }), y2.isRoot) {
        var r3 = Me();
        Re(), n3.onError(e3, { sagaStack: r3 });
      }
      s2 = e3, l2 && l2.reject(e3);
    } else
      e3 === X ? f2 = we : f2 !== we && (f2 = Ne), u2 = e3, l2 && l2.resolve(e3);
    y2.cont(e3, t3), y2.joiners.forEach(function(n4) {
      n4.cb(e3, t3);
    }), y2.joiners = null;
  }
  var y2 = ((i2 = {})[q] = true, i2.id = r2, i2.meta = o2, i2.isRoot = a2, i2.context = p2, i2.joiners = [], i2.queue = v2, i2.cancel = function() {
    f2 === me && (f2 = we, v2.cancelAll(), h2(X, false));
  }, i2.cont = c2, i2.end = h2, i2.setContext = function(n4) {
    "production" !== process.env.NODE_ENV && pn(n4, G, bn("task", n4)), vn(p2, n4);
  }, i2.toPromise = function() {
    return l2 || ((n4 = {}).promise = new Promise(function(e3, t3) {
      n4.resolve = e3, n4.reject = t3;
    }), l2 = n4, f2 === be ? l2.reject(s2) : f2 !== me && l2.resolve(u2)), l2.promise;
    var n4;
  }, i2.isRunning = function() {
    return f2 === me;
  }, i2.isCancelled = function() {
    return f2 === we || f2 === me && e2.status === we;
  }, i2.isAborted = function() {
    return f2 === be;
  }, i2.result = function() {
    return u2;
  }, i2.error = function() {
    return s2;
  }, i2);
  return y2;
}
function Ue(n3, e2, t2, r2, o2, a2, c2) {
  if ("production" !== process.env.NODE_ENV && e2[dn])
    throw new Error("redux-saga doesn't support async generators, please use only regular ones");
  var i2 = n3.finalizeRunEffect(function(e3, t3, r3) {
    if (J(e3))
      Oe(e3, r3);
    else if (Q(e3))
      Ue(n3, e3, s2.context, t3, o2, false, r3);
    else if (e3 && e3[R]) {
      (0, De[e3.type])(n3, e3.payload, r3, f2);
    } else
      r3(e3);
  });
  l2.cancel = fn;
  var u2 = { meta: o2, cancel: function() {
    u2.status === me && (u2.status = we, l2(X));
  }, status: me }, s2 = Le(n3, u2, t2, r2, o2, a2, c2), f2 = { task: s2, digestEffect: d2 };
  return c2 && (c2.cancel = s2.cancel), l2(), s2;
  function l2(n4, t3) {
    try {
      var o3;
      t3 ? (o3 = e2.throw(n4), Re()) : Sn(n4) ? (u2.status = we, l2.cancel(), o3 = H(e2.return) ? e2.return(X) : { done: true, value: X }) : o3 = _n(n4) ? H(e2.return) ? e2.return() : { done: true } : e2.next(n4), o3.done ? (u2.status !== we && (u2.status = Ne), u2.cont(o3.value)) : d2(o3.value, r2, l2);
    } catch (n5) {
      if (u2.status === we)
        throw n5;
      u2.status = be, u2.cont(n5, true);
    }
  }
  function d2(e3, t3, r3, o3) {
    void 0 === o3 && (o3 = "");
    var a3, c3 = ke();
    function u3(t4, o4) {
      a3 || (a3 = true, r3.cancel = fn, n3.sagaMonitor && (o4 ? n3.sagaMonitor.effectRejected(c3, t4) : n3.sagaMonitor.effectResolved(c3, t4)), o4 && Pe(e3), r3(t4, o4));
    }
    n3.sagaMonitor && n3.sagaMonitor.effectTriggered({ effectId: c3, parentEffectId: t3, label: o3, effect: e3 }), u3.cancel = fn, r3.cancel = function() {
      a3 || (a3 = true, u3.cancel(), u3.cancel = fn, n3.sagaMonitor && n3.sagaMonitor.effectCancelled(c3));
    }, i2(e3, c3, u3);
  }
}
var qe = "runSaga(options, saga, ...args): saga argument must be a Generator function!";
function Xe(n3, e2) {
  var t2 = n3.channel, r2 = void 0 === t2 ? ge() : t2, o2 = n3.dispatch, a2 = n3.getState, c2 = n3.context, i2 = void 0 === c2 ? {} : c2, u2 = n3.sagaMonitor, s2 = n3.effectMiddlewares, f2 = n3.onError, l2 = void 0 === f2 ? mn : f2;
  "production" !== process.env.NODE_ENV && pn(e2, H, qe);
  for (var d2 = arguments.length, p2 = new Array(d2 > 2 ? d2 - 2 : 0), v2 = 2; v2 < d2; v2++)
    p2[v2 - 2] = arguments[v2];
  var h2 = e2.apply(void 0, p2);
  "production" !== process.env.NODE_ENV && pn(h2, Q, qe);
  var y2, E2 = ke();
  if (u2 && (u2.rootSagaStarted = u2.rootSagaStarted || fn, u2.effectTriggered = u2.effectTriggered || fn, u2.effectResolved = u2.effectResolved || fn, u2.effectRejected = u2.effectRejected || fn, u2.effectCancelled = u2.effectCancelled || fn, u2.actionDispatched = u2.actionDispatched || fn, u2.rootSagaStarted({ effectId: E2, saga: e2, args: p2 })), "production" !== process.env.NODE_ENV) {
    if (K(o2) && pn(o2, H, "dispatch must be a function"), K(a2) && pn(a2, H, "getState must be a function"), K(s2)) {
      var g2 = "effectMiddlewares must be an array of functions";
      pn(s2, F, g2), s2.forEach(function(n4) {
        return pn(n4, H, g2);
      });
    }
    pn(l2, H, "onError passed to the redux-saga is not a function!");
  }
  if (s2) {
    var m2 = jn.apply(void 0, s2);
    y2 = function(n4) {
      return function(e3, t3, r3) {
        return m2(function(e4) {
          return n4(e4, t3, r3);
        })(e3);
      };
    };
  } else
    y2 = ln;
  var w2 = { channel: r2, dispatch: On(o2), getState: a2, sagaMonitor: u2, onError: l2, finalizeRunEffect: y2 };
  return te(function() {
    var n4 = Ue(w2, h2, i2, E2, Dn(e2), true, void 0);
    return u2 && u2.effectResolved(E2, n4), n4;
  });
}
function ze(n3) {
  var e2, o2 = void 0 === n3 ? {} : n3, a2 = o2.context, c2 = void 0 === a2 ? {} : a2, i2 = o2.channel, u2 = void 0 === i2 ? ge() : i2, s2 = o2.sagaMonitor, f2 = r(o2, ["context", "channel", "sagaMonitor"]);
  function l2(n4) {
    var r2 = n4.getState, o3 = n4.dispatch;
    return e2 = Xe.bind(null, t({}, f2, { context: c2, channel: u2, dispatch: o3, getState: r2, sagaMonitor: s2 })), function(n5) {
      return function(e3) {
        s2 && s2.actionDispatched && s2.actionDispatched(e3);
        var t2 = n5(e3);
        return u2.put(e3), t2;
      };
    };
  }
  return "production" !== process.env.NODE_ENV && pn(u2, en, "options.channel passed to the Saga middleware is not a channel"), l2.run = function() {
    if ("production" !== process.env.NODE_ENV && !e2)
      throw new Error("Before running a Saga, you must mount the Saga middleware on the Store using applyMiddleware");
    return e2.apply(void 0, arguments);
  }, l2.setContext = function(n4) {
    "production" !== process.env.NODE_ENV && pn(n4, G, bn("sagaMiddleware", n4)), vn(c2, n4);
  }, l2;
}
var Be = function(n3) {
  return { done: true, value: n3 };
}, We = {};
function Ke(n3) {
  return en(n3) ? "channel" : tn(n3) ? String(n3) : H(n3) ? n3.name : String(n3);
}
function He(n3, e2, t2) {
  var r2, o2, a2, c2 = e2;
  function i2(e3, t3) {
    if (c2 === We)
      return Be(e3);
    if (t3 && !o2)
      throw c2 = We, t3;
    r2 && r2(e3);
    var i3 = t3 ? n3[o2](t3) : n3[c2]();
    return c2 = i3.nextState, a2 = i3.effect, r2 = i3.stateUpdater, o2 = i3.errorState, c2 === We ? Be(e3) : a2;
  }
  return gn(i2, function(n4) {
    return i2(null, n4);
  }, t2);
}
function Ye(n3, e2) {
  for (var t2 = arguments.length, r2 = new Array(t2 > 2 ? t2 - 2 : 0), o2 = 2; o2 < t2; o2++)
    r2[o2 - 2] = arguments[o2];
  var a2, c2 = { done: false, value: qn(n3) }, i2 = function(n4) {
    return a2 = n4;
  };
  return He({ q1: function() {
    return { nextState: "q2", effect: c2, stateUpdater: i2 };
  }, q2: function() {
    return { nextState: "q1", effect: (n4 = a2, { done: false, value: Yn.apply(void 0, [e2].concat(r2, [n4])) }) };
    var n4;
  } }, "q1", "takeEvery(" + Ke(n3) + ", " + e2.name + ")");
}
function Fe(n3, e2) {
  for (var t2 = arguments.length, r2 = new Array(t2 > 2 ? t2 - 2 : 0), o2 = 2; o2 < t2; o2++)
    r2[o2 - 2] = arguments[o2];
  var a2, c2, i2 = { done: false, value: qn(n3) }, u2 = function(n4) {
    return { done: false, value: Yn.apply(void 0, [e2].concat(r2, [n4])) };
  }, s2 = function(n4) {
    return { done: false, value: Gn(n4) };
  }, f2 = function(n4) {
    return a2 = n4;
  }, l2 = function(n4) {
    return c2 = n4;
  };
  return He({ q1: function() {
    return { nextState: "q2", effect: i2, stateUpdater: l2 };
  }, q2: function() {
    return a2 ? { nextState: "q3", effect: s2(a2) } : { nextState: "q1", effect: u2(c2), stateUpdater: f2 };
  }, q3: function() {
    return { nextState: "q1", effect: u2(c2), stateUpdater: f2 };
  } }, "q1", "takeLatest(" + Ke(n3) + ", " + e2.name + ")");
}
var Ge = function(n3, e2, t2) {
  pn(e2, K, n3.name + " requires a pattern or channel"), pn(t2, K, n3.name + " requires a saga parameter");
};
function Je(n3, e2) {
  "production" !== process.env.NODE_ENV && Ge(Je, n3, e2);
  for (var t2 = arguments.length, r2 = new Array(t2 > 2 ? t2 - 2 : 0), o2 = 2; o2 < t2; o2++)
    r2[o2 - 2] = arguments[o2];
  return Yn.apply(void 0, [Ye, n3, e2].concat(r2));
}
function Qe(n3, e2) {
  "production" !== process.env.NODE_ENV && Ge(Qe, n3, e2);
  for (var t2 = arguments.length, r2 = new Array(t2 > 2 ? t2 - 2 : 0), o2 = 2; o2 < t2; o2++)
    r2[o2 - 2] = arguments[o2];
  return Yn.apply(void 0, [Fe, n3, e2].concat(r2));
}
export {
  zn as a,
  Hn as b,
  v as c,
  Qn as d,
  Je as e,
  Fn as f,
  ze as g,
  l as h,
  A as i,
  E as j,
  Xn as p,
  b as r,
  Jn as s,
  Qe as t
};
